Mmap Group

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Functions
Mmap Group
Eina

These functions provide helpers for safe mmap handling. More...

## Functions
Eina_Bool | eina_mmap_safety_enabled_set (Eina_Bool enabled)
| Enable or disable safe mmaped IO handling. More...
Eina_Bool | eina_mmap_safety_enabled_get (void)
| Get the enabled state of mmap safety. More...

## Detailed Description

These functions provide helpers for safe mmap handling.

Since
  1.1.0

## Function Documentation

Eina_Bool eina_mmap_safety_enabled_set | ( | Eina_Bool | enabled | ) |

Enable or disable safe mmaped IO handling.

Parameters

  enabled | The enabled state (to enable, pass EINA_TRUE)

Returns
  EINA_TRUE on success, EINA_FALSE on failure.

This enables (if possible on your platform) a signal handler for SIGBUS, that replaces the "bad page" with a page of 0's (from /dev/zero) if a SIGBUS occurs. This allows for safe mmap() of files that may truncate or from files on devices with IO errors. Normally these cases will result in a SIGBUS being delivered (and termination of your process), but when "mmap safety" is enabled, this will not occur. Instead a page of bytes of the value 0 will replace the "bad page", allowing the process to continue and allow its own parsing error detection to safely abort the operation without the process falling apart.

If you disable mmap safety, the SIGBUS handler will be restored to its default handler. Note that eina_file_map_all() and eina_file_map_new() will automatically enable mmap safety as they provide an mmaped file IO layer, and rely on mmap to not fail for any part of the file.

If you set up your own SIGBUS handler, then this will effectively disable the safe mmap handling and make you liable to crashes on IO to or from such "damaged files" that would take down your process.

Since
  1.1.0

References eina_cpu_page_size(), EINA_FALSE, EINA_LOG_COLOR_DEFAULT, eina_log_domain_register(), EINA_LOG_ERR, and fcntl().

Referenced by eet_identity_open(), eet_identity_print(), eina_file_map_all(), and eina_file_map_new().

Eina_Bool eina_mmap_safety_enabled_get | ( | void |  | ) |

Get the enabled state of mmap safety.

Returns
  The safety state (EINA_TRUE if enabled)

This returns the mmap safety state set by eina_mmap_safety_enabled_set(). See eina_mmap_safety_enabled_set() for more information.

Since
  1.1.0